        BEG             ; Sieve algorithm for primes less than 255
TRUE    EQU     1
Max     EQU     126
MaxP1   EQU     127

Entry                   ; BEGIN
        LDI     Max
        TAX
        LDI     TRUE
Loop                    ; FOR X := Max DOWNTO 0 DO
        STX     Sieve   ;   Sieve[X] := TRUE
        DEX
        BPZ     Loop    ; END
        LDI     2
        JSR     Write   ; 2 as a special case
        CLA
        STA     I       ; I := 0
Test    CPI     Max     ; WHILE I <= Max DO
        BPZ     Halt
        TAX
        LDX     Sieve   ;   A := Sieve[I]
        BZE     INCI    ;   IF NOT Sieve[I] THEN
        LDA     I
        SHL
        ADI     3
        STA     Step    ;     Step := 2*I+3
        JSR     Write   ;     WriteLn(2*I+3)
        LDA     I
        STA     K       ;     K := I
Remove  TAX             ;     REPEAT
        CLA             ;       A := FALSE
        STX     Sieve   ;       Sieve[K] := FALSE
        LDA     K
        ADD     Step
        STA     K       ;       K := K + 2*I+3
        BCS     INCI    ;       but exit if overflow
        CPI     MaxP1
        BNG     Remove  ;     UNTIL K > Max (or overflow)
                        ;   END (*IF*)
INCI    LDA     I
        INC
        STA     I       ;   I := I + 1
        BRN     Test    ; END (*WHILE*)
Halt    HLT

Write                   ; PROCEDURE WriteLn(A)
CR      EQU     13
LF      EQU     10
        OTC             ; A as an unsigned number
        LDI     CR      ; CR/LF pair for line mark
        OTA
        LDI     LF
        OTA
        RET             ; END WriteLn

I       DS      1       ; VAR I, K, Step : BYTE
K       DS      1
Step    DS      1
Sieve   DS      MaxP1   ; VAR Sieve : ARRAY [0 .. 127] OF BOOLEAN
        END
